use std::{fs::File, io::Read, sync::Arc};

use poem::{
    handler,
    web::{headers::ContentType, Data, Path, WithContentType},
    IntoResponse,
};

use crate::app_state::AppState;

#[handler]
pub async fn handler(
    id: Path<u64>,
    state: Data<&Arc<AppState>>,
) -> Result<WithContentType<Vec<u8>>, poem::Error> {
    let book = state.calibre.scalar_book(*id).unwrap();
    let cover_path = state.config.library_path.join(book.path).join("cover.jpg");
    let mut cover = File::open(cover_path).unwrap();
    let mut data = Vec::new();
    cover.read_to_end(&mut data).unwrap();

    Ok(data.with_content_type(ContentType::jpeg().to_string()))
}
